diff -ruNp linux-2.6.23.16/fs/splice.c linux-2.6.23.16-cher1/fs/splice.c
--- linux-2.6.23.16/fs/splice.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/splice.c	2008-02-12 11:21:39.000000000 +0300
@@ -1540,6 +1540,9 @@ asmlinkage long sys_vmsplice(int fd, con
 	else if (unlikely(!nr_segs))
 		return 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	error = -EBADF;
 	file = fget_light(fd, &fput);
 	if (file) {
@@ -1562,6 +1565,9 @@ asmlinkage long sys_splice(int fd_in, lo
 	struct file *in, *out;
 	int fput_in, fput_out;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (unlikely(!len))
 		return 0;
 
@@ -1779,6 +1785,9 @@ asmlinkage long sys_tee(int fdin, int fd
 	struct file *in;
 	int error, fput_in;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (unlikely(!len))
 		return 0;
 
diff -ruNp linux-2.6.23.16/fs/stat.c linux-2.6.23.16-cher1/fs/stat.c
--- linux-2.6.23.16/fs/stat.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/stat.c	2008-02-12 11:21:39.000000000 +0300
@@ -155,8 +155,12 @@ static int cp_old_stat(struct kstat *sta
 asmlinkage long sys_stat(char __user * filename, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+        error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -165,8 +169,12 @@ asmlinkage long sys_stat(char __user * f
 asmlinkage long sys_lstat(char __user * filename, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
+        error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -175,8 +183,12 @@ asmlinkage long sys_lstat(char __user * 
 asmlinkage long sys_fstat(unsigned int fd, struct __old_kernel_stat __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+	error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_old_stat(&stat, statbuf);
 
@@ -238,8 +250,12 @@ static int cp_new_stat(struct kstat *sta
 asmlinkage long sys_newstat(char __user *filename, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat_fd(AT_FDCWD, filename, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+	error = vfs_stat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -249,8 +265,12 @@ asmlinkage long sys_newstat(char __user 
 asmlinkage long sys_newlstat(char __user *filename, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
+	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
+	error = vfs_lstat_fd(AT_FDCWD, filename, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -264,6 +284,9 @@ asmlinkage long sys_newfstatat(int dfd, 
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -283,8 +306,12 @@ out:
 asmlinkage long sys_newfstat(unsigned int fd, struct stat __user *statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+	error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_new_stat(&stat, statbuf);
 
@@ -297,6 +324,9 @@ asmlinkage long sys_readlinkat(int dfd, 
 	struct nameidata nd;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (bufsiz <= 0)
 		return -EINVAL;
 
@@ -367,8 +397,12 @@ static long cp_new_stat64(struct kstat *
 asmlinkage long sys_stat64(char __user * filename, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_stat(filename, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+	error = vfs_stat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -377,8 +411,12 @@ asmlinkage long sys_stat64(char __user *
 asmlinkage long sys_lstat64(char __user * filename, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_lstat(filename, &stat);
+	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
+	error = vfs_lstat(filename, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -387,8 +425,12 @@ asmlinkage long sys_lstat64(char __user 
 asmlinkage long sys_fstat64(unsigned long fd, struct stat64 __user * statbuf)
 {
 	struct kstat stat;
-	int error = vfs_fstat(fd, &stat);
+	int error;
+
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
 
+	error = vfs_fstat(fd, &stat);
 	if (!error)
 		error = cp_new_stat64(&stat, statbuf);
 
@@ -401,6 +443,9 @@ asmlinkage long sys_fstatat64(int dfd, c
 	struct kstat stat;
 	int error = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if ((flag & ~AT_SYMLINK_NOFOLLOW) != 0)
 		goto out;
 
@@ -468,3 +513,9 @@ void inode_set_bytes(struct inode *inode
 }
 
 EXPORT_SYMBOL(inode_set_bytes);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/super.c linux-2.6.23.16-cher1/fs/super.c
--- linux-2.6.23.16/fs/super.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/super.c	2008-02-12 11:21:39.000000000 +0300
@@ -540,6 +540,9 @@ asmlinkage long sys_ustat(unsigned dev, 
         struct kstatfs sbuf;
 	int err = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
         s = user_get_super(new_decode_dev(dev));
         if (s == NULL)
                 goto out;
@@ -953,3 +956,9 @@ struct vfsmount *kern_mount(struct file_
 }
 
 EXPORT_SYMBOL(kern_mount);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/sync.c linux-2.6.23.16-cher1/fs/sync.c
--- linux-2.6.23.16/fs/sync.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/sync.c	2008-02-12 11:21:39.000000000 +0300
@@ -38,6 +38,9 @@ static void do_sync(unsigned long wait)
 
 asmlinkage long sys_sync(void)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	do_sync(1);
 	return 0;
 }
@@ -120,11 +123,17 @@ static long __do_fsync(unsigned int fd, 
 
 asmlinkage long sys_fsync(unsigned int fd)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return __do_fsync(fd, 0);
 }
 
 asmlinkage long sys_fdatasync(unsigned int fd)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	return __do_fsync(fd, 1);
 }
 
@@ -183,6 +192,9 @@ asmlinkage long sys_sync_file_range(int 
 	int fput_needed;
 	umode_t i_mode;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = -EINVAL;
 	if (flags & ~VALID_FLAGS)
 		goto out;
@@ -282,3 +294,9 @@ out:
 	return ret;
 }
 EXPORT_SYMBOL_GPL(do_sync_mapping_range);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/timerfd.c linux-2.6.23.16-cher1/fs/timerfd.c
--- linux-2.6.23.16/fs/timerfd.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/timerfd.c	2008-02-12 11:21:39.000000000 +0300
@@ -159,6 +159,9 @@ asmlinkage long sys_timerfd(int ufd, int
 	struct inode *inode;
 	struct itimerspec ktmr;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (copy_from_user(&ktmr, utmr, sizeof(ktmr)))
 		return -EFAULT;
 
diff -ruNp linux-2.6.23.16/fs/utimes.c linux-2.6.23.16-cher1/fs/utimes.c
--- linux-2.6.23.16/fs/utimes.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/utimes.c	2008-02-12 11:21:39.000000000 +0300
@@ -26,6 +26,11 @@ asmlinkage long sys_utime(char __user *f
 {
 	struct timespec tv[2];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (times) {
 		if (get_user(tv[0].tv_sec, &times->actime) ||
 		    get_user(tv[1].tv_sec, &times->modtime))
@@ -133,6 +138,11 @@ asmlinkage long sys_utimensat(int dfd, c
 {
 	struct timespec tstimes[2];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&tstimes, utimes, sizeof(tstimes)))
 			return -EFAULT;
@@ -159,6 +169,11 @@ asmlinkage long sys_futimesat(int dfd, c
 	struct timeval times[2];
 	struct timespec tstimes[2];
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (utimes) {
 		if (copy_from_user(&times, utimes, sizeof(times)))
 			return -EFAULT;
@@ -185,3 +200,9 @@ asmlinkage long sys_utimes(char __user *
 {
 	return sys_futimesat(AT_FDCWD, filename, utimes);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/fs/xattr.c linux-2.6.23.16-cher1/fs/xattr.c
--- linux-2.6.23.16/fs/xattr.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/fs/xattr.c	2008-02-12 11:21:39.000000000 +0300
@@ -232,6 +232,11 @@ sys_setxattr(char __user *path, char __u
 	struct nameidata nd;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -247,6 +252,11 @@ sys_lsetxattr(char __user *path, char __
 	struct nameidata nd;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -263,6 +273,11 @@ sys_fsetxattr(int fd, char __user *name,
 	struct dentry *dentry;
 	int error = -EBADF;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -317,6 +332,11 @@ sys_getxattr(char __user *path, char __u
 	struct nameidata nd;
 	ssize_t error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -332,6 +352,11 @@ sys_lgetxattr(char __user *path, char __
 	struct nameidata nd;
 	ssize_t error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -346,6 +371,11 @@ sys_fgetxattr(int fd, char __user *name,
 	struct file *f;
 	ssize_t error = -EBADF;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -391,6 +421,11 @@ sys_listxattr(char __user *path, char __
 	struct nameidata nd;
 	ssize_t error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -405,6 +440,11 @@ sys_llistxattr(char __user *path, char _
 	struct nameidata nd;
 	ssize_t error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -419,6 +459,11 @@ sys_flistxattr(int fd, char __user *list
 	struct file *f;
 	ssize_t error = -EBADF;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -452,6 +497,11 @@ sys_removexattr(char __user *path, char 
 	struct nameidata nd;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk(path, &nd);
 	if (error)
 		return error;
@@ -466,6 +516,11 @@ sys_lremovexattr(char __user *path, char
 	struct nameidata nd;
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	error = user_path_walk_link(path, &nd);
 	if (error)
 		return error;
@@ -481,6 +536,11 @@ sys_fremovexattr(int fd, char __user *na
 	struct dentry *dentry;
 	int error = -EBADF;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	f = fget(fd);
 	if (!f)
 		return error;
@@ -618,3 +678,9 @@ EXPORT_SYMBOL(generic_getxattr);
 EXPORT_SYMBOL(generic_listxattr);
 EXPORT_SYMBOL(generic_setxattr);
 EXPORT_SYMBOL(generic_removexattr);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/include/asm-generic/resource.h linux-2.6.23.16-cher1/include/asm-generic/resource.h
--- linux-2.6.23.16/include/asm-generic/resource.h	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/include/asm-generic/resource.h	2008-02-12 11:21:39.000000000 +0300
@@ -44,8 +44,9 @@
 #define RLIMIT_NICE		13	/* max nice prio allowed to raise to
 					   0-39 for nice level 19 .. -20 */
 #define RLIMIT_RTPRIO		14	/* maximum realtime priority */
+#define RLIMIT_MCPU             15      /* millisecond cpu limit */
 
-#define RLIM_NLIMITS		15
+#define RLIM_NLIMITS		16
 
 /*
  * SuS says limits have to be unsigned.
@@ -86,6 +87,7 @@
 	[RLIMIT_MSGQUEUE]	= {   MQ_BYTES_MAX,   MQ_BYTES_MAX },	\
 	[RLIMIT_NICE]		= { 0, 0 },				\
 	[RLIMIT_RTPRIO]		= { 0, 0 },				\
+	[RLIMIT_MCPU]		= {  RLIM_INFINITY,  RLIM_INFINITY },	\
 }
 
 #endif	/* __KERNEL__ */
diff -ruNp linux-2.6.23.16/include/linux/ptrace.h linux-2.6.23.16-cher1/include/linux/ptrace.h
--- linux-2.6.23.16/include/linux/ptrace.h	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/include/linux/ptrace.h	2008-02-12 11:21:39.000000000 +0300
@@ -27,6 +27,9 @@
 #define PTRACE_GETSIGINFO	0x4202
 #define PTRACE_SETSIGINFO	0x4203
 
+#define PTRACE_MEMLIMIT         0x4280
+#define PTRACE_NO_SYSCALLS      0x4281
+
 /* options set using PTRACE_SETOPTIONS */
 #define PTRACE_O_TRACESYSGOOD	0x00000001
 #define PTRACE_O_TRACEFORK	0x00000002
diff -ruNp linux-2.6.23.16/include/linux/sched.h linux-2.6.23.16-cher1/include/linux/sched.h
--- linux-2.6.23.16/include/linux/sched.h	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/include/linux/sched.h	2008-02-12 11:21:39.000000000 +0300
@@ -934,6 +934,15 @@ struct sched_entity {
 #endif
 };
 
+/* sandbox flags */
+enum {
+	SBOX_NO_SYSCALLS  = 1,   /* disable most "dangerous" syscalls */
+        SBOX_NO_EXEC      = 2,   /* disable exec syscall */
+        SBOX_MEMLIMITON   = 4,   /* enable memory limit check */
+        SBOX_WAS_MEMLIMIT = 8,   /* memory limit happened  */
+	SBOX_WAS_SECURITY = 16,  /* was security violation */
+};
+
 struct task_struct {
 	volatile long state;	/* -1 unrunnable, 0 runnable, >0 stopped */
 	void *stack;
@@ -1196,6 +1205,8 @@ struct task_struct {
 #ifdef CONFIG_FAULT_INJECTION
 	int make_it_fail;
 #endif
+	/* sandbox flags */
+	int sbox_flags;
 };
 
 /*
diff -ruNp linux-2.6.23.16/ipc/mqueue.c linux-2.6.23.16-cher1/ipc/mqueue.c
--- linux-2.6.23.16/ipc/mqueue.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/ipc/mqueue.c	2008-02-12 11:21:39.000000000 +0300
@@ -659,6 +659,9 @@ asmlinkage long sys_mq_open(const char _
 	char *name;
 	int fd, error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	error = audit_mq_open(oflag, mode, u_attr);
 	if (error != 0)
 		return error;
@@ -727,6 +730,9 @@ asmlinkage long sys_mq_unlink(const char
 	struct dentry *dentry;
 	struct inode *inode = NULL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	name = getname(u_name);
 	if (IS_ERR(name))
 		return PTR_ERR(name);
@@ -823,6 +829,9 @@ asmlinkage long sys_mq_timedsend(mqd_t m
 	long timeout;
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = audit_mq_timedsend(mqdes, msg_len, msg_prio, u_abs_timeout);
 	if (ret != 0)
 		return ret;
@@ -910,6 +919,9 @@ asmlinkage ssize_t sys_mq_timedreceive(m
 	struct mqueue_inode_info *info;
 	struct ext_wait_queue wait;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = audit_mq_timedreceive(mqdes, msg_len, u_msg_prio, u_abs_timeout);
 	if (ret != 0)
 		return ret;
@@ -994,6 +1006,9 @@ asmlinkage long sys_mq_notify(mqd_t mqde
 	struct mqueue_inode_info *info;
 	struct sk_buff *nc;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	ret = audit_mq_notify(mqdes, u_notification);
 	if (ret != 0)
 		return ret;
@@ -1119,6 +1134,9 @@ asmlinkage long sys_mq_getsetattr(mqd_t 
 	struct inode *inode;
 	struct mqueue_inode_info *info;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (u_mqstat != NULL) {
 		if (copy_from_user(&mqstat, u_mqstat, sizeof(struct mq_attr)))
 			return -EFAULT;
@@ -1287,3 +1305,9 @@ out_sysctl:
 }
 
 __initcall(init_mqueue_fs);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/ipc/msg.c linux-2.6.23.16-cher1/ipc/msg.c
--- linux-2.6.23.16/ipc/msg.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/ipc/msg.c	2008-02-12 11:21:39.000000000 +0300
@@ -258,6 +258,11 @@ asmlinkage long sys_msgget(key_t key, in
 	int id, ret = -EPERM;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 	
 	mutex_lock(&msg_ids(ns).mutex);
@@ -390,6 +395,11 @@ asmlinkage long sys_msgctl(int msqid, in
 	int err, version;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (msqid < 0 || cmd < 0)
 		return -EINVAL;
 
@@ -723,6 +733,11 @@ sys_msgsnd(int msqid, struct msgbuf __us
 {
 	long mtype;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (get_user(mtype, &msgp->mtype))
 		return -EFAULT;
 	return do_msgsnd(msqid, mtype, msgp->mtext, msgsz, msgflg);
@@ -908,6 +923,11 @@ asmlinkage long sys_msgrcv(int msqid, st
 {
 	long err, mtype;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	err =  do_msgrcv(msqid, &mtype, msgp->mtext, msgsz, msgtyp, msgflg);
 	if (err < 0)
 		goto out;
@@ -941,3 +961,9 @@ static int sysvipc_msg_proc_show(struct 
 			msq->q_ctime);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/ipc/sem.c linux-2.6.23.16-cher1/ipc/sem.c
--- linux-2.6.23.16/ipc/sem.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/ipc/sem.c	2008-02-12 11:21:39.000000000 +0300
@@ -261,6 +261,11 @@ asmlinkage long sys_semget (key_t key, i
 	struct sem_array *sma;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	if (nsems < 0 || nsems > ns->sc_semmsl)
@@ -924,6 +929,11 @@ asmlinkage long sys_semctl (int semid, i
 	int version;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (semid < 0)
 		return -EINVAL;
 
@@ -1120,6 +1130,11 @@ asmlinkage long sys_semtimedop(int semid
 	unsigned long jiffies_left = 0;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	if (nsops < 1 || semid < 0)
@@ -1413,3 +1428,9 @@ static int sysvipc_sem_proc_show(struct 
 			  sma->sem_ctime);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/ipc/shm.c linux-2.6.23.16-cher1/ipc/shm.c
--- linux-2.6.23.16/ipc/shm.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/ipc/shm.c	2008-02-12 11:21:39.000000000 +0300
@@ -423,6 +423,11 @@ asmlinkage long sys_shmget (key_t key, s
 	int err, id = 0;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	ns = current->nsproxy->ipc_ns;
 
 	mutex_lock(&shm_ids(ns).mutex);
@@ -584,6 +589,11 @@ asmlinkage long sys_shmctl (int shmid, i
 	int err, version;
 	struct ipc_namespace *ns;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (cmd < 0 || shmid < 0) {
 		err = -EINVAL;
 		goto out;
@@ -987,6 +997,11 @@ asmlinkage long sys_shmat(int shmid, cha
 	unsigned long ret;
 	long err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	err = do_shmat(shmid, shmaddr, shmflg, &ret);
 	if (err)
 		return err;
@@ -1006,6 +1021,11 @@ asmlinkage long sys_shmdt(char __user *s
 	loff_t size = 0;
 	int retval = -EINVAL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (addr & ~PAGE_MASK)
 		return retval;
 
@@ -1111,3 +1131,9 @@ static int sysvipc_shm_proc_show(struct 
 			  shp->shm_ctim);
 }
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/acct.c linux-2.6.23.16-cher1/kernel/acct.c
--- linux-2.6.23.16/kernel/acct.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/acct.c	2008-02-12 11:21:39.000000000 +0300
@@ -253,6 +253,11 @@ asmlinkage long sys_acct(const char __us
 {
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (!capable(CAP_SYS_PACCT))
 		return -EPERM;
 
@@ -597,3 +602,9 @@ void acct_process(void)
 	do_acct_process(file);
 	fput(file);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/capability.c linux-2.6.23.16-cher1/kernel/capability.c
--- linux-2.6.23.16/kernel/capability.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/capability.c	2008-02-12 11:21:39.000000000 +0300
@@ -49,6 +49,9 @@ asmlinkage long sys_capget(cap_user_head
      struct task_struct *target;
      struct __user_cap_data_struct data;
 
+     if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
      if (get_user(version, &header->version))
 	     return -EFAULT;
 
@@ -178,6 +181,11 @@ asmlinkage long sys_capset(cap_user_head
      int ret;
      pid_t pid;
 
+     if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+     }
+
      if (get_user(version, &header->version))
 	     return -EFAULT; 
 
@@ -251,3 +259,9 @@ int capable(int cap)
 	return __capable(current, cap);
 }
 EXPORT_SYMBOL(capable);
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/compat.c linux-2.6.23.16-cher1/kernel/compat.c
--- linux-2.6.23.16/kernel/compat.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/compat.c	2008-02-12 11:21:39.000000000 +0300
@@ -442,6 +442,9 @@ asmlinkage long compat_sys_sched_setaffi
 	cpumask_t new_mask;
 	int retval;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	retval = compat_get_user_cpu_mask(user_mask_ptr, len, &new_mask);
 	if (retval)
 		return retval;
@@ -457,6 +460,9 @@ asmlinkage long compat_sys_sched_getaffi
 	unsigned long *k;
 	unsigned int min_length = sizeof(cpumask_t);
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (NR_CPUS <= BITS_PER_COMPAT_LONG)
 		min_length = sizeof(compat_ulong_t);
 
@@ -782,6 +788,9 @@ compat_sys_rt_sigtimedwait (compat_sigse
 	siginfo_t info;
 	long ret, timeout = 0;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (sigsetsize != sizeof(sigset_t))
 		return -EINVAL;
 
@@ -861,6 +870,9 @@ asmlinkage long compat_sys_stime(compat_
 	struct timespec tv;
 	int err;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (get_user(tv.tv_sec, tptr))
 		return -EFAULT;
 
@@ -909,6 +921,9 @@ asmlinkage long compat_sys_adjtimex(stru
 	struct timex txc;
 	int ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	memset(&txc, 0, sizeof(struct timex));
 
 	if (!access_ok(VERIFY_READ, utp, sizeof(struct compat_timex)) ||
@@ -1039,6 +1054,9 @@ compat_sys_sysinfo(struct compat_sysinfo
 {
 	struct sysinfo s;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	do_sysinfo(&s);
 
 	/* Check to see if any memory value is too large for 32-bit and scale
diff -ruNp linux-2.6.23.16/kernel/exec_domain.c linux-2.6.23.16-cher1/kernel/exec_domain.c
--- linux-2.6.23.16/kernel/exec_domain.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/exec_domain.c	2008-02-12 11:21:39.000000000 +0300
@@ -194,6 +194,9 @@ sys_personality(u_long personality)
 {
 	u_long old = current->personality;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+		return old;
+
 	if (personality != 0xffffffff) {
 		set_personality(personality);
 		if (current->personality != personality)
diff -ruNp linux-2.6.23.16/kernel/exit.c linux-2.6.23.16-cher1/kernel/exit.c
--- linux-2.6.23.16/kernel/exit.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/exit.c	2008-02-12 11:21:39.000000000 +0300
@@ -1168,7 +1168,7 @@ static int wait_task_zombie(struct task_
 {
 	unsigned long state;
 	int retval;
-	int status;
+	int status, status2;
 
 	if (unlikely(noreap)) {
 		pid_t pid = p->pid;
@@ -1268,8 +1268,13 @@ static int wait_task_zombie(struct task_
 	retval = ru ? getrusage(p, RUSAGE_BOTH, ru) : 0;
 	status = (p->signal->flags & SIGNAL_GROUP_EXIT)
 		? p->signal->group_exit_code : p->exit_code;
+        status2 = status;
+        if ((p->sbox_flags & SBOX_WAS_MEMLIMIT))
+                status2 |= 0x10000;
+	if ((p->sbox_flags & SBOX_WAS_SECURITY))
+		status2 |= 0x20000;
 	if (!retval && stat_addr)
-		retval = put_user(status, stat_addr);
+		retval = put_user(status2, stat_addr);
 	if (!retval && infop)
 		retval = put_user(SIGCHLD, &infop->si_signo);
 	if (!retval && infop)
@@ -1679,6 +1684,9 @@ asmlinkage long sys_waitid(int which, pi
 {
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WNOWAIT|WEXITED|WSTOPPED|WCONTINUED))
 		return -EINVAL;
 	if (!(options & (WEXITED|WSTOPPED|WCONTINUED)))
@@ -1713,6 +1721,9 @@ asmlinkage long sys_wait4(pid_t pid, int
 {
 	long ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	if (options & ~(WNOHANG|WUNTRACED|WCONTINUED|
 			__WNOTHREAD|__WCLONE|__WALL))
 		return -EINVAL;
@@ -1735,3 +1746,9 @@ asmlinkage long sys_waitpid(pid_t pid, i
 }
 
 #endif
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/fork.c linux-2.6.23.16-cher1/kernel/fork.c
--- linux-2.6.23.16/kernel/fork.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/fork.c	2008-02-12 11:21:39.000000000 +0300
@@ -890,7 +890,10 @@ static inline int copy_signal(unsigned l
 	memcpy(sig->rlim, current->signal->rlim, sizeof sig->rlim);
 	task_unlock(current->group_leader);
 
-	if (sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY) {
+	if (sig->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY) {
+		tsk->it_prof_expires =
+			msecs_to_cputime(sig->rlim[RLIMIT_MCPU].rlim_cur);
+	} else if (sig->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY) {
 		/*
 		 * New sole thread in the process gets an expiry time
 		 * of the whole CPU time limit.
@@ -1242,6 +1245,7 @@ static struct task_struct *copy_process(
 		    !cputime_eq(current->signal->it_prof_expires,
 				cputime_zero) ||
 		    current->signal->rlim[RLIMIT_CPU].rlim_cur != RLIM_INFINITY ||
+		    current->signal->rlim[RLIMIT_MCPU].rlim_cur != RLIM_INFINITY ||
 		    !list_empty(&current->signal->cpu_timers[0]) ||
 		    !list_empty(&current->signal->cpu_timers[1]) ||
 		    !list_empty(&current->signal->cpu_timers[2])) {
@@ -1371,9 +1375,15 @@ long do_fork(unsigned long clone_flags,
 {
 	struct task_struct *p;
 	int trace = 0;
-	struct pid *pid = alloc_pid();
+	struct pid *pid = NULL;
 	long nr;
 
+        if (unlikely(current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
+	pid = alloc_pid();
 	if (!pid)
 		return -EAGAIN;
 	nr = pid->nr;
@@ -1604,6 +1614,9 @@ asmlinkage long sys_unshare(unsigned lon
 	struct sem_undo_list *new_ulist = NULL;
 	struct nsproxy *new_nsproxy = NULL, *old_nsproxy = NULL;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	check_unshare_flags(&unshare_flags);
 
 	/* Return -EINVAL for all unsupported flags */
@@ -1688,3 +1701,9 @@ bad_unshare_cleanup_thread:
 bad_unshare_out:
 	return err;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/kernel/kexec.c linux-2.6.23.16-cher1/kernel/kexec.c
--- linux-2.6.23.16/kernel/kexec.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/kernel/kexec.c	2008-02-12 11:21:39.000000000 +0300
@@ -921,6 +921,9 @@ asmlinkage long sys_kexec_load(unsigned 
 	int locked;
 	int result;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	/* We only trust the superuser with rebooting the system. */
 	if (!capable(CAP_SYS_BOOT))
 		return -EPERM;
